#include <iostream>

typedef long long ll;

using namespace std;

long long dp[5001][5001][2], sum[5001][5001][2];

const ll P = 1000000007;

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);

    long long n, k;
    cin >> n >> k;
    dp[0][0][0] = 1;
    sum[0][0][0] = 1;
    for (int i = 1; i <= n; i++)
    {
        for (int j = 1; j <= i; j++)
        {
            if (j == i)
            {
                dp[i][j][0] = 1;
                sum[i][j][0] = (1 + sum[i][j - 1][0]) % P;
            } else {
                if (j == i - 1 && j != 1)
                {
                    dp[i][j][0] = 1;
                    sum[i][j][0] = (1 + sum[i][j - 1][0]) % P;
                } else {
                    dp[i][j][0] = sum[i - j][j - 1][1];
                    if (i - j == j - 1)
                    {
                        dp[i][j][0]++;
                        dp[i][j][0] = dp[i][j][0] % P;
                    }
                    if (i > j * 2)
                        dp[i][j][1] = (sum[i - j][i - j][0] - sum[i - j][j][0] + P) % P;
                    else
                        dp[i][j][1] = 0;
                    sum[i][j][0] = (sum[i][j - 1][0] + dp[i][j][0]) % P;
                    sum[i][j][1] = (sum[i][j - 1][1] + dp[i][j][1]) % P;
                }
            }
        }
    }
    cout << (dp[n][k][0] + dp[n][k][1]) % P;
    return 0;
}
